#!/usr/lib64/python2.4
# -*- coding: UTF-8 -*-

import controller
import xml.dom.minidom
import sys
from cgi import escape
from urllib import urlopen
from cStringIO import StringIO

def getHtmlDocument(scriptName):
    impl = xml.dom.minidom.getDOMImplementation()
    document = xml.dom.minidom.parseString("""<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fi"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8"></meta></head><body></body></html>""")
    dt = impl.createDocumentType('html', '-//W3C//DTD XHTML 1.0 Strict//EN', 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd')
    #document = impl.createDocument('http://www.w3.org/1999/xhtml', 'html', dt)
    document.insertBefore(dt, document.documentElement)
    
    meta1 = document.createElement('meta')
    meta1.setAttribute('content','text/html; charset=UTF-8')
    meta1.setAttribute('http-equiv','Content-Type')
    
    styleLink = document.createElement('link')
    styleLink.setAttribute('type','text/css')
    styleLink.setAttribute('rel','StyleSheet')
    styleLink.setAttribute('href','style.css')

    jQueryScript = document.createElement('script')
    jQueryScript.setAttribute('type','text/javascript')
    jQueryScript.setAttribute('src','jquery-1.5.2.min.js')
    jQueryScript.appendChild(document.createTextNode(''))

    fileInputScript = document.createElement('script')
    fileInputScript.setAttribute('type','text/javascript')
    fileInputScript.setAttribute('src',scriptName)
    fileInputScript.appendChild(document.createTextNode(''))

    titleElement = document.createElement('title')
    titleTxt = document.createTextNode('Harkkatarkastin')
    titleElement.appendChild(titleTxt)

    head = document.getElementsByTagName('head')[0]
    head.appendChild(meta1)
    head.appendChild(styleLink)
    head.appendChild(jQueryScript)
    head.appendChild(fileInputScript)
    head.appendChild(titleElement)
    
    return document

def firstPage(name, nameError, email, emailError, fileDiskError, fileUrl, fileUrlError):

    document = xml.dom.minidom.parse('/var/www/virtual.hosts/sovellusprojektit.it.jyu.fi/parsi/sovellus/firstPage.html')

    for scriptElement in document.getElementsByTagName('script'):
        scriptElement.appendChild(document.createTextNode(''))

    for p in document.getElementsByTagName('p'):
        for input in p.getElementsByTagName('input'):
            id = input.getAttribute('id')
            if id == 'name':
                input.setAttribute('value', name)
                p.getElementsByTagName('span')[0].appendChild(document.createTextNode(nameError))
            elif id == 'email':
                input.setAttribute('value', email)
                p.getElementsByTagName('span')[0].appendChild(document.createTextNode(emailError))
                #input.nextSibling.appendChild(document.createTextNode(emailError))
            elif id == 'filerequest':
                p.getElementsByTagName('span')[0].appendChild(document.createTextNode(fileDiskError))
            elif id == 'fileUrl':
                input.setAttribute('value', fileUrl)            	
                p.getElementsByTagName('span')[0].appendChild(document.createTextNode(fileUrlError))
            

    return document.toxml()


def feedBackPage(feedback, name, email):
    #Much better way: parse DOM from feedbackPage.html and insert stuff in the DOM-tree.
    #@see: firstPage()
    #Problem: path to the html file?

    document = getHtmlDocument('feedbackpage.js')
    
    heading1 = document.createElement('h1')
    heading1.appendChild(document.createTextNode('Palaute'))
	
    nameParagraph = document.createElement('p')
    nameParagraph.appendChild(document.createTextNode('Nimi: ' + name))
	
    hiddenName = document.createElement('input')
    hiddenName.setAttribute('type','hidden')
    hiddenName.setAttribute('value',name)
    hiddenName.setAttribute('id','name')
    nameParagraph.appendChild(hiddenName)
	
    emailParagraph = document.createElement('p')
    emailParagraph.appendChild(document.createTextNode('Shkposti: ' + email))
	
    sendEmailButton = document.createElement('input')
    sendEmailButton.setAttribute('type','button')
    sendEmailButton.setAttribute('value','Lhet palaute mys shkpostiin')
    sendEmailButton.setAttribute('id','sendToEmailButton')
    emailParagraph.appendChild(sendEmailButton)
	
    hiddenEmail = document.createElement('input')
    hiddenEmail.setAttribute('type','hidden')
    hiddenEmail.setAttribute('value',email)
    hiddenEmail.setAttribute('id','emailAddress')
    emailParagraph.appendChild(hiddenEmail)
	
    dateParagraph = document.createElement('p')
    dateParagraph.appendChild(document.createTextNode('Tarkastettu: '))
	
    dateSpan = document.createElement('span')
    dateSpan.setAttribute('id','date')
    dateParagraph.appendChild(dateSpan)

    body = document.getElementsByTagName('body')[0]
    body.appendChild(heading1)
    body.appendChild(nameParagraph)
    body.appendChild(emailParagraph)
    body.appendChild(dateParagraph)
    
    #Insert feedback here.
    #Either create the dom-tree here or get the dom-tree from controller.
    for item in feedback:
#        body.appendChild(document.createTextNode(str(item)))
        body.appendChild(item)
    #body.appendChild(document.createTextNode(str(feedback)))
    
    return document.toprettyxml("  ", "\n", 'utf-8')

def index(req):
    req.content_type = "text/html ; charset=utf-8"
    form = req.form
    feedback = []
    name = form.getfirst("name")
    email = form.getfirst("email")
    sent = form.getfirst("submitButton")
    fileUrl = form.getfirst("fileUrl")
    radioValue = form.getfirst("fileInputSelection")
    #feedback.append(name)

    if sent:
        #feedback.append("Nimi: " + name)
        #feedback.append("Sähköpostiosoite: " + email)
        nameError = ""
        emailError = ""
        goForward = True

        if name == "" or name == None:
            nameError = u"* Pakollinen kenttä!"
            goForward = False
        if  email == "" or email == None:
            emailError = u"* Pakollinen kenttä!"
            goForward = False
        if goForward:
            tmpfile = None
            if radioValue.value == "file":
                tmpfile = req.form['filerequest']

                if tmpfile.filename == "":
                    inputError = u"* Tiedostoa ei löytynyt!"
                    return firstPage(escape(name), nameError, escape(email), emailError, inputError, escape(fileUrl), "")
                controller.beginInspection(tmpfile.file, tmpfile.filename, feedback, email)

            elif radioValue.value == "url":
                try:
                    tmpfile = urlopen(fileUrl)
                    controller.beginInspection(StringIO(tmpfile.read()), fileUrl, feedback, email)
                except IOError:
                    inputError = u"* Url-osoite oli väärin!"
                    return firstPage(escape(name), nameError, escape(email), emailError, "", escape(fileUrl), inputError)
            #else: then what?

            return feedBackPage(feedback, escape(name), escape(email))

        else:
            sent = None
            return firstPage(escape(name), nameError, escape(email), emailError, "", escape(fileUrl), "")
#    return firstPage("", "", "", "", "", "http://", "")
    #req.write(str(sys.path))
    return firstPage("", "", "", "", "", "http://", "")

