'''
Created on Mar 8, 2011

@author: juiitamm
'''
import sys
import zipfile
#import xml.dom.minidom
from xml.dom import minidom

#class MsoMeta:
''' Module for getting Microsoft Office file formats' docx, pptx, and xlsx meta informations.

Public methods:
getElementValue -- gets the value of a given element.
getCreator -- gets the creator of the document.
getLastModifier -- gets the last modifier of the document.
getCreateDate -- gets the date when the document was created.
getLastModifiedDate -- gets the date when the document was last modified.
'''

#    def __init__(self, filename):
#        '''
#        filename -- the name or path of the document-file.
#        '''
#        self.filename = filename
#        
#        if zipfile.is_zipfile(filename):
#            mydocument = zipfile.ZipFile(filename)
#            coreFile = mydocument.read('docProps/core.xml')
#            self.coreXml = minidom.parseString(coreFile)
            
    
def getElementValue(elementTagName, coreXml):
    ''' Return the text content of a given element.
    
    elementTagName -- the tag name of the element.
    
    return -- text content of the element. 
              If no text content found, return message.
    '''
    if (coreXml):
        value = ""
        try:
            value = coreXml.getElementsByTagName(elementTagName)[0].firstChild.nodeValue
        except IndexError:
            return elementTagName + " - tag not found"
        return value
    
def getCreator(coreXml):
    ''' Return the creator of the document.'''
    return getElementValue('dc:creator', coreXml)

def getLastModifier(coreXml):
    '''Return the last modifier'''
    return getElementValue('dcterms:created', coreXml)

def getCreateDate(coreXml):
    return getElementValue('dcterms:created', coreXml)

def getLastModifiedDate(coreXml):
    return getElementValue('dcterms:modified', coreXml)
    
def getRevision(coreXml):
    return getElementValue('cp:revision', coreXml)


if __name__ == "__main__":
    
    filename = 'sampleFiles/docx/Teija_Holtta.docx'
    
    if zipfile.is_zipfile(filename):
        mydocument = zipfile.ZipFile(filename)
        coreFile = mydocument.read('docProps/core.xml')
        docxCoreXml = minidom.parseString(coreFile)
    
#    docxMetaReader = MsoMeta("docx_demo.docx")
#    print docxMetaReader.filename
    print 'Creator: ' + getCreator(docxCoreXml)
    print 'Last modified by: ' + getLastModifier(docxCoreXml)
    print 'Created: ' + getCreateDate(docxCoreXml)
    print 'Modified: ' + getLastModifiedDate(docxCoreXml)
    print 'Revision: ' + getRevision(docxCoreXml)
    
    